//+------------------------------------------------------------------+

extern double TakeProfit = 500;
extern double Lots = 1;
extern double StopLoss=500;
extern double TrailingStop = 200;
extern double MovingFast=5;
extern double MovingSlow=26;
extern double Macd_limit=1.5; // Limiting the trade below the Macd_limit

double Macd_0,Macd_1,Macd_2,Signal_0,Signal_1,MaFast_0,MaFast_1,MaFast_2,MaSlow_0,MaSlow_1,RStIndex,SAR_0,SAR_1,SAR_2;
int cnt, ticket, total;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
// initial data checks
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   Macd_0=iMACD(NULL,0,MovingFast,MovingSlow,9,PRICE_CLOSE,MODE_MAIN,0);
   Macd_1=iMACD(NULL,0,MovingFast,MovingSlow,9,PRICE_CLOSE,MODE_MAIN,1);
   Signal_0=iMACD(NULL,0,MovingFast,MovingSlow,9,PRICE_CLOSE,MODE_SIGNAL,0);
   Signal_1=iMACD(NULL,0,MovingFast,MovingSlow,9,PRICE_CLOSE,MODE_SIGNAL,1);
   MaFast_0=iMA(NULL,0,MovingFast,0,MODE_EMA,PRICE_TYPICAL,0);
   MaFast_1=iMA(NULL,0,MovingFast,0,MODE_EMA,PRICE_TYPICAL,1);
   MaFast_2=iMA(NULL,0,MovingFast,0,MODE_EMA,PRICE_TYPICAL,2);
   MaSlow_0=iMA(NULL,0,MovingSlow,0,MODE_EMA,PRICE_TYPICAL,0);
   MaSlow_1=iMA(NULL,0,MovingSlow,0,MODE_EMA,PRICE_TYPICAL,1);
   SAR_0=iSAR(Symbol(),0,0.02,0.2,0);
   SAR_1=iSAR(Symbol(),0,0.02,0.2,1);
   SAR_2=iSAR(Symbol(),0,0.02,0.2,2);

   double icci_0 = iCCI(NULL, 0, 14, PRICE_TYPICAL, 0);
   double icci_1 = iCCI(NULL, 0, 14, PRICE_TYPICAL, 1);
   double icci_2 = iCCI(NULL, 0, 14, PRICE_TYPICAL, 2);
   
//**************************************************************************************************************************

   total=OrdersTotal();
   while (total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if (SAR_2>MaFast_2&&SAR_1>MaFast_1&&SAR_0<MaFast_0)
         {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if (SAR_2<MaFast_2&&SAR_1<MaFast_1&&SAR_0>MaFast_0)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",16384,0,Red);

         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      
//****************************************************************************************************************     
//Terms for exit
    
   
  for(cnt=0;cnt<total;cnt++)
     {
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            //Exit Long?
      if (Macd_0<Macd_1&&Macd_1>Macd_2)
               {
                OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
               }
           }
         else // go to short position
           {
            // Exit Short?
      if (Macd_0>Macd_1&&Macd_1<Macd_2)

              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
           }
        }
     }
   return(0);
  }
  return(0);
     }
// the end.